﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.actionscriptfacile.ui.text.UITextField;
	import com.actionscriptfacile.ui.combo.element.ComboBoxElement;
	import com.actionscriptfacile.ui.utils.UIMargins;
	import com.as3facileexemple.skin.classic.DefaultComboBoxSkin;
	import com.actionscriptfacile.ui.combo.ComboBox;

	import flash.events.MouseEvent;
	import flash.text.TextFieldType;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.system.Security;
	import flash.events.Event;
	import flash.display.Sprite;

	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private static const DEFAULT_VIDEO_ID : String = "OOrH5tfWorg";// id d'une vidéo you tube
		
		// implémenter vos propres bouttons de contrôles (play, pause...)
		private static const PLAYER_URL : String = "http://www.youtube.com/apiplayer?version=3";
		// avec les contrôles du player You Tube
		//private static const PLAYER_URL : String = "http://www.youtube.com/v/"+DEFAULT_VIDEO_ID+"?version=3";
		
		
		private static const SECURITY_DOMAIN : String = "http://www.youtube.com";

		private static const QUALITY_TO_PLAYER_WIDTH : Object = {small:320, medium:550, large:854, hd720:1280};
		
		private static const STATE_ENDED : Number = 0;
		private static const STATE_PLAYING : Number = 1;
		private static const STATE_PAUSED : Number = 2;
		private static const STATE_CUED : Number = 5;
		
		
		private var player : Object;
		private var isWidescreen : Boolean;
		private var isQualityPopulated : Boolean;
		
		private var loader : Loader;

		private var oDisplayPlayer : Sprite;
		private var oTxtSeek : UITextField;
		private var qualityComboBox : ComboBox;


		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			// Autorise le player à accéder à votre swf
			Security.allowDomain(SECURITY_DOMAIN);
			setupUi();
			setupPlayerLoader();
		}

		/**
		 * Initialisation de l'interface utilisateur.
		 * 
		 */
		private function setupUi() : void
		{
			isQualityPopulated = false;
			isWidescreen = true; // 16/9
			
			// Création du bnouton Play / Pause
			var oBtnPlayPause:DefaultButton = new DefaultButton();
			oBtnPlayPause.getObject().label = "Play / Pause";
			oBtnPlayPause.getObject().x = 30;
			oBtnPlayPause.getObject().y = 355;
			oBtnPlayPause.getObject().addEventListener ( MouseEvent.CLICK, playButtonClickHandler );
			
			// Création de la combobox qui contient les différentes qualité de la vidéo
			qualityComboBox = new ComboBox();
			qualityComboBox.applySkin( new DefaultComboBoxSkin() );
			// Définition du format du Titre de la ComboBox
			qualityComboBox.currentLabel = "Qualité : ";
			qualityComboBox.currentElement.labelField.changeFormat("font", "Arial",-1,-1,true);
            qualityComboBox.currentElement.labelField.changeFormat("color", Math.random() * 0X00FFFFFF,-1,-1,true);
            qualityComboBox.currentElement.labelField.changeFormat("size", 15,-1,-1,true);
            qualityComboBox.currentElement.labelField.changeFormat("bold", true,-1,-1,true);
            qualityComboBox.currentElement.labelField.alignCenter();
			
			qualityComboBox.scrollDirection = ComboBox.SCROLL_UP;
			
			qualityComboBox.resize(100, 40);
			qualityComboBox.x = oBtnPlayPause.getObject().x + oBtnPlayPause.getObject().width + 10;
			qualityComboBox.y = oBtnPlayPause.getObject().y;
			qualityComboBox.componentsHeight = 25;// hauteur des éléments de la CombobBox
            qualityComboBox.margins = new UIMargins( 2, 2, 2, 2 );// ajout des marges au contenu de la liste
			qualityComboBox.addEventListener(Event.CHANGE, qualityComboBoxChangeHandler ); 
			
			var oBtnSound : DefaultButton = new DefaultButton();
			oBtnSound.getObject().label = "Son on/off";
			oBtnSound.getObject().x = qualityComboBox.x + qualityComboBox.width + 10;
			oBtnSound.getObject().y = qualityComboBox.y;
			oBtnSound.getObject().addEventListener ( MouseEvent.CLICK, soundButtonClickHandler );
			
			var oBtnSeek : DefaultButton = new DefaultButton();
			oBtnSeek.getObject().label = "Démarrer à (s) :";
			oBtnSeek.getObject().x = oBtnSound.getObject().x + oBtnSound.getObject().width + 10;
			oBtnSeek.getObject().y = qualityComboBox.y;
			oBtnSeek.getObject().addEventListener ( MouseEvent.CLICK, seekButtonClickHandler );
			
			oTxtSeek = new UITextField();
			oTxtSeek.x = oBtnSeek.getObject().x + oBtnSeek.getObject().width + 10;
			oTxtSeek.y = qualityComboBox.y;
			oTxtSeek.maxWidth = oTxtSeek.width = 33;
			oTxtSeek.text = "0";
			oTxtSeek.type = TextFieldType.INPUT;
			oTxtSeek.alignLeft(); // aligne le texte
			oTxtSeek.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxtSeek.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtSeek.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtSeek.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur

			oDisplayPlayer = new Sprite();
			addChild( oDisplayPlayer );
			
			addChild(qualityComboBox);
			addChild( oBtnPlayPause );
			addChild( oBtnSeek );
			addChild( oTxtSeek );
			addChild( oBtnSound );
		}

		/**
		 * Eteind ou allume le son.
		 * 
		 */
		private function soundButtonClickHandler(event : MouseEvent) : void
		{
			if( player.isMuted() )	player.unMute();
			else player.mute();
		}
		
		
		/**
		 * Lecture de la vidéo à partir d'une durée définit.
		 * 
		 */
		private function seekButtonClickHandler(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "seekButtonClickHandler : "+oTxtSeek.text);
			player.seekTo(oTxtSeek.text);// lire la vidéo à xxx secondes
		}


		/**
		 * Initialisation du player you tube.
		 * 
		 */
		private function setupPlayerLoader() : void
		{
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.INIT, onLoadPlayerComplete);
			loader.load(new URLRequest(PLAYER_URL));
		}
		
		
		/**
		 * Chargement du player you tube terminé.
		 * 
		 */
		private function onLoadPlayerComplete(event : Event) : void
		{
			MonsterDebugger.trace(this, "onLoadPlayerComplete");
			// var loader : Loader = event.target as Loader;
			oDisplayPlayer.addChild(loader);
			loader.content.addEventListener("onReady", onPlayerReady);
			loader.content.addEventListener("onError", onPlayerError);
			loader.content.addEventListener("onStateChange", onPlayerStateChange);
			loader.content.addEventListener("onPlaybackQualityChange", onVideoPlaybackQualityChange);			
		}

	
		/**
		 * Le player est prêt à être utilisé, après la diffusion de cet évènement.
		 * Utilisation de cueVideoById, loadVideoById, cueVideoByUrl and loadVideoByUrl
		 * 
		 */
		private function onPlayerReady(event : Event) : void
		{
			// Event.data contains the event parameter, which is the Player API ID
			MonsterDebugger.trace(this, "player ready:");
			MonsterDebugger.trace(this, Object(event).data);

			// var loader : Loader = event.target as Loader;
			
			// récupération du player
			player = loader.content;
			
			// Définit les dimensions du player pour votre application
			//player.setSize(550, 350);
			
			// chargement d'une vidéo à partir de son id (vidéo en pause)
			player.cueVideoById(DEFAULT_VIDEO_ID);
			
			// charge la vidéo et mise en lecture directe
			// player.loadVideoById(DEFAULT_VIDEO_ID);
		}
		
		
		/**
		 * Erreur sur le player.
		 * 
		 */
		private function onPlayerError(event : Event) : void
		{
			// Event.data contient le code d'erreur
			MonsterDebugger.trace(this, "player error:");
			MonsterDebugger.trace(this, Object(event).data);
		}
		
		
		/**
		 * Changement d'état du player.
		 * 
		 */
		private function onPlayerStateChange(event : Event) : void
		{
			// Event.data contient le nouvel état du player
			MonsterDebugger.trace(this, "---> player state:");
			MonsterDebugger.trace(this, Object(event).data);
			
			switch (Object(event).data)
			{
				case STATE_ENDED:
					break;
					
				case STATE_PLAYING:
					if (!isQualityPopulated)	populateQualityComboBox();
					break;
					
				case STATE_PAUSED:
					break;
					
				case STATE_CUED:
					resizePlayer("medium");
					break;
			}
		}
		
		
		/**
		 * Redimensionne automatiquement le player 
		 * en fonction de la qualité de la vidéo.
		 * 
		 */
		private function resizePlayer(qualityLevel : String) : void
		{
			var newWidth : Number = QUALITY_TO_PLAYER_WIDTH[qualityLevel] || 640;
			var newHeight : Number;

			if (isWidescreen)
			{
				// écran (le plus souvent) du player en 16:9 player.
				newHeight = newWidth * 9 / 16;
			}
			else
			{
				// écran du player en 4:3 player.
				newHeight = newWidth * 3 / 4;
			}

			MonsterDebugger.trace(this, "isWidescreen est "+ String(isWidescreen)+ ". Size: width "+ newWidth+" - height  "+ newHeight);
			
			player.setSize(newWidth, newHeight);// définit la taille du player

			// Centre le player redimensionné sur le stage
			player.x = (stage.stageWidth - newWidth) / 2;
			player.y = (stage.stageHeight - newHeight) / 2 - 20;
			
			player.visible = true;
		}
		
		
		/**
		 * Mise à jour de la qualité de la vidéo.
		 * 
		 */
		private function onVideoPlaybackQualityChange(event : Event) : void
		{
			// Event.data contains the event parameter, which is the new video quality
			MonsterDebugger.trace(this, "video quality:");
			MonsterDebugger.trace(this, Object(event).data);
		}
		
		
		
		/**
		 * Appuie la combobox pour choisir la qualité de la vidéo.
		 * 
		 */
		private function qualityComboBoxChangeHandler(event : Event) : void
		{
			var qualityLevel : String = qualityComboBox.currentLabel;
			MonsterDebugger.trace(this, "change video quality : "+qualityLevel);
			player.setPlaybackQuality(qualityLevel);
		}

		
		/**
		 * Appuie sur le bouton Play / Pause.
		 * 
		 */
		private function playButtonClickHandler(event : MouseEvent) : void
		{
			var nStatePlayer:Number = player.getPlayerState();// récupère l'état du Player You Tube
			
			switch (nStatePlayer)
			{
				case -1:// vidéo non démarrée
				case 0:// vidéo terminée
				case 2:// vidéo en pause
					player.playVideo();
					break;
				case 1:// vidéo en cours de lecture
					player.pauseVideo();
					break;
				case 3:// vidéo en train d'être mise en buffer
					break;
				case 5:// vidéo indicée
					break;
				default:
					player.playVideo();
					break;
			}
		}

		
		
		/**
		 * Remplit la combobox avec les différentes qualité de la vidéo.
		 * 
		 */
		private function populateQualityComboBox() : void
		{
			isQualityPopulated = true;
			
			var currentQuality : String = player.getPlaybackQuality();
			qualityComboBox.currentLabel = currentQuality;
			
			var qualities : Array = player.getAvailableQualityLevels();
			
			MonsterDebugger.trace(this, "qualities :");
			MonsterDebugger.trace(this, qualities);
			
			var boxElement:ComboBoxElement;
			// ajout des éléments dans la combobox
			for (var i : int = 0; i < qualities.length; i++)
            {
                boxElement = qualityComboBox.addElement( qualities[i], qualities[i] );
                boxElement.labelField.changeFormat("font", "Arial");// changement de la couleur du texte
                boxElement.labelField.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur du texte
                boxElement.labelField.changeFormat("size", 14);// changement de la taille de la police du texte
            }

		}
		
		
		
	}
}
